<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="110px">
      <el-form-item label="年度" prop="year">
        <el-input v-model="queryParams.year" placeholder="请输入年度" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="定向Key" prop="directKey">
        <el-input v-model="queryParams.directKey" placeholder="请输入定向Key" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="录取公式" prop="enrollFormula">
        <el-input v-model="queryParams.enrollFormula" placeholder="请输入录取公式" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="文化科目" prop="cultural">
        <el-input v-model="queryParams.cultural" placeholder="请输入文化科目" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="专业类别" prop="professional">
        <el-input v-model="queryParams.professional" placeholder="请输入专业类别" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="专业科目" prop="subjects">
        <el-input v-model="queryParams.subjects" placeholder="请输入专业科目" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="适用省份" prop="locations">
        <el-input v-model="queryParams.locations" placeholder="请输入适用省份" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="适用考生类型" prop="examineeTypes">
        <el-input v-model="queryParams.examineeTypes" placeholder="请输入适用考生类型" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="仿真模拟卷要求" prop="conditions">
        <el-input v-model="queryParams.conditions" placeholder="请输入仿真模拟卷要求" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd"
          v-hasPermi="['learn:directKnowledge:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate"
          v-hasPermi="['learn:directKnowledge:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['learn:directKnowledge:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport"
          v-hasPermi="['learn:directKnowledge:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="directKnowledgeList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" fixed="left" />
      <el-table-column label="id" align="center" prop="id" />
      <el-table-column label="年度" align="center" prop="year" />
      <el-table-column label="定向Key" align="center" prop="directKey" />
      <el-table-column label="录取公式" align="center" prop="enrollFormula" />
      <el-table-column label="文化科目" align="center" prop="cultural" />
      <el-table-column label="专业类别" align="center" prop="professional" />
      <el-table-column label="专业科目" align="center" prop="subjects" />
      <el-table-column label="题型分布" align="center" prop="questionTypes" />
      <el-table-column label="祖级列表" align="center" prop="knowledges" />
      <el-table-column label="适用省份" align="center" prop="locations" />
      <el-table-column label="适用考生类型" align="center" prop="examineeTypes" min-width="120" />
      <el-table-column label="仿真模拟卷要求" align="center" prop="conditions" min-width="120" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" min-width="140" fixed="right">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['learn:directKnowledge:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
            v-hasPermi="['learn:directKnowledge:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize" @pagination="getList" />

    <!-- 添加或修改定向知识点关系对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="directKnowledgeRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="年度" prop="year">
          <el-input v-model="form.year" placeholder="请输入年度" />
        </el-form-item>
        <el-form-item label="定向Key" prop="directKey">
          <el-input v-model="form.directKey" placeholder="请输入定向Key" />
        </el-form-item>
        <el-form-item label="录取公式" prop="enrollFormula">
          <el-input v-model="form.enrollFormula" placeholder="请输入录取公式" />
        </el-form-item>
        <el-form-item label="文化科目" prop="cultural">
          <el-input v-model="form.cultural" placeholder="请输入文化科目" />
        </el-form-item>
        <el-form-item label="专业类别" prop="professional">
          <el-input v-model="form.professional" placeholder="请输入专业类别" />
        </el-form-item>
        <el-form-item label="专业科目" prop="subjects">
          <el-input v-model="form.subjects" placeholder="请输入专业科目" />
        </el-form-item>
        <el-form-item label="题型分布" prop="questionTypes">
          <el-input v-model="form.questionTypes" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="祖级列表" prop="knowledges">
          <el-input v-model="form.knowledges" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="适用省份" prop="locations">
          <el-input v-model="form.locations" placeholder="请输入适用省份" />
        </el-form-item>
        <el-form-item label="适用考生类型" prop="examineeTypes">
          <el-input v-model="form.examineeTypes" placeholder="请输入适用考生类型" />
        </el-form-item>
        <el-form-item label="仿真模拟卷要求" prop="conditions">
          <el-input v-model="form.conditions" placeholder="请输入仿真模拟卷要求" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="DirectKnowledge">
import { listDirectKnowledge, getDirectKnowledge, delDirectKnowledge, addDirectKnowledge, updateDirectKnowledge } from "@/api/learn/directKnowledge"

const { proxy } = getCurrentInstance()

const directKnowledgeList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    year: null,
    directKey: null,
    enrollFormula: null,
    cultural: null,
    professional: null,
    subjects: null,
    questionTypes: null,
    knowledges: null,
    locations: null,
    examineeTypes: null,
    conditions: null
  },
  rules: {
  }
})

const { queryParams, form, rules } = toRefs(data)

/** 查询定向知识点关系列表 */
function getList() {
  loading.value = true
  listDirectKnowledge(queryParams.value).then(response => {
    directKnowledgeList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    year: null,
    directKey: null,
    enrollFormula: null,
    cultural: null,
    professional: null,
    subjects: null,
    questionTypes: null,
    knowledges: null,
    locations: null,
    examineeTypes: null,
    conditions: null
  }
  proxy.resetForm("directKnowledgeRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加定向知识点关系"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _id = row.id || ids.value
  getDirectKnowledge(_id).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改定向知识点关系"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["directKnowledgeRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateDirectKnowledge(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addDirectKnowledge(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value
  proxy.$modal.confirm('是否确认删除定向知识点关系编号为"' + _ids + '"的数据项？').then(function () {
    return delDirectKnowledge(_ids)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => { })
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('learn/directKnowledge/export', {
    ...queryParams.value
  }, `directKnowledge_${new Date().getTime()}.xlsx`)
}

getList()
</script>
